package com.logicbig.example.app;


import com.logicbig.example.client.RetailBuyer;
import com.logicbig.example.client.Wholesaler;
import com.logicbig.example.service.WholeSaleOrderService;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.FilterType;

@Configuration
@ComponentScan(basePackages = "com.logicbig.example.client;com.logicbig.example.service",
        excludeFilters = @ComponentScan.Filter(
                type = FilterType.ASSIGNABLE_TYPE,
                classes = {WholeSaleOrderService.class, Wholesaler.class})

)
public class OnlineOrderApp {

    public static void main(String... strings) {
        AnnotationConfigApplicationContext context =
                new AnnotationConfigApplicationContext(OnlineOrderApp.class);
        System.out.println("-- Spring container started and is ready --");
        RetailBuyer retailBuyer = context.getBean(RetailBuyer.class);
        retailBuyer.buySomething();

        boolean wholeSaleOrderServiceRegistered =
                context.containsBean("wholeSaleOrderService");
        System.out.println("wholeSaleOrderService registered: "+ wholeSaleOrderServiceRegistered);
    }
}